/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package es.rickyepoderi.sample;

import java.io.IOException;
import javax.security.auth.callback.Callback;
import javax.security.auth.callback.CallbackHandler;
import javax.security.auth.callback.UnsupportedCallbackException;
import org.apache.wss4j.common.saml.SAMLCallback;
import org.w3c.dom.Document;

/**
 *
 * @author rickyepoderi
 */
public class KeycloakSamlCallbackHandler implements CallbackHandler {

    Document assertion;

    public KeycloakSamlCallbackHandler(Document assertion) {
        this.assertion = assertion;
    }

    @Override
    public void handle(Callback[] callbacks) throws IOException, UnsupportedCallbackException {
        if (callbacks != null) {
            for (Callback callback1 : callbacks) {
                if (callback1 instanceof SAMLCallback) {
                    SAMLCallback callback = (SAMLCallback) callback1;
                    callback.setAssertionElement(assertion.getDocumentElement());
                }
            }
        }
    }
}
