<%@page import="java.security.Principal"%>
<%@page import="java.util.List"%>
<%@page import="org.keycloak.adapters.saml.SamlPrincipal"%>
<!DOCTYPE html>
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <title>Keycloak adapter</title>
    </head>
    <body>
        <h1>Keycloak adapter</h1>
        
        <ul>
        <li><strong>remote user</strong>: <%= request.getRemoteUser() %></li>
        <li><strong>remote principal</strong>: <%= request.getUserPrincipal()%></li>
        </ul>

        <h3>SAML Principal</h3>
        <ul>
        <li><strong>SAML Subject</strong>: <%= ((SamlPrincipal)request.getUserPrincipal()).getSamlSubject() %></li>
        <li><strong>SAML format</strong>: <%= ((SamlPrincipal)request.getUserPrincipal()).getNameIDFormat() %></li>
        <%
          for (String name: ((SamlPrincipal)request.getUserPrincipal()).getAttributeNames()) {
              List<String> attrs = ((SamlPrincipal)request.getUserPrincipal()).getAttributes(name);
              out.println("<li><strong>Attribute " + name + "</strong>: " + attrs + "</li>");
          }
        %>
        <%
          for (String name: ((SamlPrincipal)request.getUserPrincipal()).getFriendlyNames()) {
              List<String> attrs = ((SamlPrincipal)request.getUserPrincipal()).getFriendlyAttributes(name);
              out.println("<li><strong>Friendly Attribute " + name + "</strong>: " + attrs + "</li>");
          }
        %>
        <%
            String assertionXml = org.keycloak.saml.processing.core.saml.v2.util.AssertionUtil.asString(
                    ((SamlPrincipal) request.getUserPrincipal()).getAssertion());
        %>
        <li><strong>Assertion</strong>: <textarea rows="8" cols="80"><%= assertionXml %></textarea></li>
        </ul>

        <form method="POST" action="EchoServlet">
            <label for="input">Input for Echo Servlet: </label>
            <input id="input" name="input" type="text"/>
            <input type="submit" value="Submit">
        </form>

        <p><a href="./?GLO=true">logout</a></p>
    </body>
</html>
